/* Copyright 2020 Canaan Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#pragma once
#include "compiler_defs.h"
#include <nncase/runtime/runtime_module.h>

BEGIN_NS_NNCASE_RT_K510

#define K510_SEC_TEXT ".text"
#define K510_SEC_DSP_TEXT ".dsp.text"
#define K510_DSP_BASEMENT 2

NNCASE_INLINE_VAR constexpr module_type_t k510_module_type = to_module_type("k510");
NNCASE_INLINE_VAR constexpr uint32_t k510_module_version = 1;

NNCASE_MODULES_K510_API result<std::unique_ptr<runtime_module>> create_k510_runtime_module();

END_NS_NNCASE_RT_K510
